commit 436ee9fec2751826bc48069d4dd320207fd9dfa4
Author: liuhongt <hongtao.liu@intel.com>
Date:   Wed Aug 26 15:24:10 2020 +0800

    Add expander for movp2hi and movp2qi.
    
    2020-08-30  Uros Bizjak    <ubizjak@gmail.com>
    
    gcc/ChangeLog:
            PR target/96744
            * config/i386/i386-expand.c (split_double_mode): Also handle
            E_P2HImode and E_P2QImode.
            * config/i386/sse.md (MASK_DWI): New define_mode_iterator.
            (mov<mode>): New expander for P2HI,P2QI.
            (*mov<mode>_internal): New define_insn_and_split to split
            movement of P2QI/P2HI to 2 movqi/movhi patterns after reload.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/i386/double_mask_reg-1.c: New test.

diff --git a/gcc/config/i386/i386-expand.c b/gcc/config/i386/i386-expand.c
index f7756ddef0f..3ee332e6dc6 100644
--- a/gcc/config/i386/i386-expand.c
+++ b/gcc/config/i386/i386-expand.c
@@ -116,6 +116,12 @@ split_double_mode (machine_mode mode, rtx operands[],
     case E_DImode:
       half_mode = SImode;
       break;
+    case E_P2HImode:
+      half_mode = HImode;
+      break;
+    case E_P2QImode:
+      half_mode = QImode;
+      break;
     default:
       gcc_unreachable ();
     }
diff --git a/gcc/testsuite/gcc.target/i386/double_mask_reg-1.c b/gcc/testsuite/gcc.target/i386/double_mask_reg-1.c
new file mode 100644
index 00000000000..79ba1ce2926
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/double_mask_reg-1.c
@@ -0,0 +1,19 @@
+/* PR target/96744  */
+/* { dg-do compile } */
+/* { dg-options "-mavx512vp2intersect -O2" } */
+
+#include<immintrin.h>
+void
+_mm512_2intersect_epi64_cut (__m512i __A, __m512i __B, __mmask8 *__U,
+    __mmask8 *__M)
+{
+  __builtin_ia32_2intersectq512 (__U, __M, (__v8di) __A, (__v8di) __B);
+}
+
+void
+_mm512_2intersect_epi32_cut (__m512i __A, __m512i __B, __mmask16 *__U,
+    __mmask16 *__M)
+{
+  __builtin_ia32_2intersectd512 (__U, __M, (__v16si) __A, (__v16si) __B);
+}
+

